#ifndef INFERNODE_HPP__
#define INFERNODE_HPP__

#include "nodes/base/base.hpp"
#include <opencv2/opencv.hpp>
#include "infer/infer.hpp"

// 日志库
#include "plog/Log.h"
#include "plog/Initializers/RollingFileInitializer.h"

namespace GNode
{

class InferNode : public BaseNode
{
public:
    InferNode() = delete;
    InferNode(const std::string& name) : BaseNode(name, NODE_TYPE::MID_NODE) {}
    virtual ~InferNode()  { stop(); };

    void set_model_instance(std::shared_ptr<Infer> model, int device_id=0)
    {
        model_ = model;
        device_id_ = device_id;
    }

    void handle_data(std::shared_ptr<meta::BaseData>& meta_data) override;

private:
    std::shared_ptr<Infer> model_ = nullptr;
    int device_id_;
};

}

#endif  // INFERNODE_HPP__